import { jsx as m, jsxs as z } from "react/jsx-runtime";
import W, { useRef as y, useEffect as R, useCallback as J, useState as L, useMemo as K, useId as Q, useReducer as Y, useLayoutEffect as $ } from "react";
import a from "clsx";
const w = "av-text-input", be = "av-text-input-simple", Z = "av-text-input-wrapper", N = "av-text-input-helper-text";
function B() {
  const e = y(!1);
  return R(() => (e.current = !0, () => {
    e.current = !1;
  }), []), J(() => e.current, []);
}
const ee = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function te(e) {
  const r = B(), t = y(0), n = y(null), [l, o] = L(ee), c = K(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((i) => {
    const p = i[0];
    p && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      n.current && r() && o(p.contentRect);
    }));
  }), [r]);
  return R(() => (n.current && (c == null || c.observe(n.current, e)), () => {
    c == null || c.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [c, e]), [n, l];
}
function re(e) {
  const r = Q();
  if (!e)
    return r;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${r}`;
  if (typeof e == "object") {
    const { id: t, prefix: n = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${n}${t}` : `${n}${r}`;
  }
}
const U = "SET_ANNOUNCEMENT", D = "CLEAR_ANNOUNCEMENT", ne = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, le = (e, r) => {
  switch (r == null ? void 0 : r.type) {
    case U:
      return {
        ...e,
        announcement: r.payload
      };
    case D:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, ce = ({
  onAnnouncementClear: e,
  dispatch: r
}) => {
  r({
    type: D
  }), typeof e == "function" && e();
}, P = ({
  children: e,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: n,
  dispatch: l
}) => {
  clearTimeout(t.current), e !== null && l({
    type: U,
    payload: e
  }), r && (t.current = setTimeout(
    () => ce({
      onAnnouncementClear: n,
      dispatch: l
    }),
    r
  ));
}, ae = ({
  children: e,
  announcementTimeoutRef: r,
  announcementDelay: t,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: l,
  onAnnouncementClear: o,
  dispatch: c
}) => {
  clearTimeout(r.current), t ? r.current = setTimeout(P, t, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: o,
    dispatch: c
  }) : P({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: o,
    dispatch: c
  });
};
function oe({
  children: e,
  className: r,
  politeness: t,
  role: n = null,
  announcementDelay: l,
  clearAnnouncementDelay: o,
  onAnnouncementClear: c,
  visible: i,
  ...p
}) {
  const f = y(null), x = y(null), [g, s] = Y(le, {
    announcement: null
  });
  let d = t;
  typeof d > "u" && (d = n ? ne[n] : "assertive"), R(() => {
    ae({
      announcementTimeoutRef: f,
      announcementDelay: l,
      children: e,
      clearAnnouncementDelay: o,
      clearAnnouncementTimeoutRef: x,
      onAnnouncementClear: c,
      dispatch: s
    });
  }, [
    e,
    l,
    o,
    c
  ]);
  const u = a(r, {
    "sr-only": !i
  });
  return /* @__PURE__ */ m(
    "div",
    {
      "aria-live": d,
      ...n && { role: n },
      className: u,
      ...p,
      children: g.announcement
    }
  );
}
/*!
  @versini/ui-liveregion v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_LIVEREGION__ || (window.__VERSINI_UI_LIVEREGION__ = {
    version: "1.1.0",
    buildTime: "12/25/2024 12:30 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
/*!
  @versini/ui-spacing v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.0.0",
    buildTime: "12/25/2024 12:30 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const se = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, ie = ({
  mode: e
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), ue = ({
  focusMode: e
}) => a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), pe = ({
  noBorder: e,
  error: r
}) => a("border-2", {
  "border-border-dark": !e && !r,
  "focus:border-border-dark": !e && r,
  "border-border-error-dark": !e && r,
  "border-transparent": e
}), de = ({
  disabled: e,
  raw: r,
  error: t,
  mode: n
}) => {
  if (r)
    return "";
  if (e)
    return a("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-lighter": n === "system",
      "text-copy-lighter dark:text-copy-dark": n === "alt-system"
    });
  if (t)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": n === "system",
      "text-copy-lighter dark:text-copy-error-dark": n === "alt-system"
    });
}, me = ({
  error: e,
  raw: r,
  mode: t,
  disabled: n
}) => {
  if (r)
    return "";
  if (n)
    return a(
      N,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return a(N, "absolute px-2 font-medium", {
      "text-copy-lighter": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-lighter": t === "system",
      "text-copy-lighter dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return a(N, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": t === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": t === "alt-system"
    });
}, ye = ({
  className: e,
  inputClassName: r,
  raw: t,
  disabled: n,
  noBorder: l,
  error: o,
  spacing: c,
  mode: i,
  focusMode: p,
  size: f,
  rightElementClassName: x
}) => {
  const g = t ? e : a(
    "relative flex w-full flex-col justify-center",
    Z,
    e,
    se(c)
  );
  let s = "";
  switch (f) {
    case "xs":
      s = "h-8";
      break;
    case "sm":
      s = "h-10";
      break;
    case "lg":
      s = "h-14";
      break;
    case "xl":
      s = "h-16";
      break;
    default:
      s = "h-12";
      break;
  }
  const d = t ? a(r) : a(
    w,
    r,
    s,
    "rounded-md text-base px-4",
    ie({ mode: i }),
    ue({ focusMode: p }),
    pe({ noBorder: l, error: o }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": n
    }
  ), u = t ? void 0 : "sr-only", b = de({
    disabled: n,
    raw: t,
    error: o,
    mode: i
  }), A = me({
    error: o,
    raw: t,
    mode: i,
    disabled: n
  }), I = t ? void 0 : a("absolute right-3", x);
  return {
    wrapper: g,
    input: d,
    accessibleLabel: u,
    visibleLabel: b,
    helperText: A,
    rightElement: I
  };
}, fe = W.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: n = !1,
    raw: l = !1,
    className: o,
    inputClassName: c,
    mode: i = "system",
    focusMode: p = "system",
    disabled: f = !1,
    noBorder: x = !1,
    labelId: g,
    labelHidden: s = !1,
    type: d = "text",
    helperText: u = "",
    rightElement: b,
    rightElementClassName: A,
    spacing: I,
    size: E = "md",
    ...M
  }, F) => {
    const [O, T] = te(), [V, j] = L(0), k = re({ id: e, prefix: `${w}-` }), X = `${r} error, ${u}`, v = y(null), _ = y(null), G = {
      xs: { label: "-25px", helperText: "30px" },
      sm: { label: "-29px", helperText: "34px" },
      md: { label: "-33px", helperText: "38px" },
      lg: { label: "-15px", helperText: "22px" },
      xl: { label: "-19px", helperText: "25px" }
    }, h = ye({
      className: o,
      inputClassName: c,
      error: n,
      raw: l,
      focusMode: p,
      disabled: f,
      noBorder: x,
      spacing: I,
      mode: i,
      size: E,
      rightElementClassName: A
    });
    return $(() => {
      T && T.width && j(T.width + 18 + 10);
    }, [T]), $(() => {
      var C, S;
      const { label: q, helperText: H } = G[E];
      (C = v == null ? void 0 : v.current) == null || C.style.setProperty("--av-text-input-label", q), (S = _ == null ? void 0 : _.current) == null || S.style.setProperty(
        "--av-text-input-helper-text",
        H
      );
    }, [E]), /* @__PURE__ */ z("div", { className: h.wrapper, children: [
      /* @__PURE__ */ m(
        "label",
        {
          htmlFor: k,
          id: g,
          className: h.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ m(
        "input",
        {
          ref: F,
          id: k,
          name: r,
          type: d,
          disabled: f,
          placeholder: l ? void 0 : " ",
          className: h.input,
          ...u && { "aria-describedby": `${k}-helper` },
          ...n && { "aria-invalid": "true" },
          ...b && !l && { style: { paddingRight: V } },
          ...M
        }
      ),
      !l && !s && /* @__PURE__ */ m(
        "label",
        {
          ref: v,
          "aria-hidden": !0,
          htmlFor: k,
          className: h.visibleLabel,
          children: t
        }
      ),
      u && /* @__PURE__ */ m(
        "div",
        {
          ref: _,
          id: `${k}-helper`,
          className: h.helperText,
          children: u
        }
      ),
      b && /* @__PURE__ */ m(
        "div",
        {
          ref: O,
          className: h.rightElement,
          children: b
        }
      ),
      n && u && /* @__PURE__ */ m(oe, { politeness: "polite", clearAnnouncementDelay: 500, children: X })
    ] });
  }
);
fe.displayName = "TextInput";
export {
  w as TEXT_INPUT_CLASSNAME,
  N as TEXT_INPUT_HELPER_TEXT_CLASSNAME,
  be as TEXT_INPUT_SIMPLE_CLASSNAME,
  Z as TEXT_INPUT_WRAPPER_CLASSNAME,
  fe as TextInput,
  oe as x
};
